/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.ergebniskonflikt;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.ergebniskonflikt.boundary.AbstractErgebnisKonfliktSearchParameters;
import de.ivu.elect.business.ergebniskonflikt.boundary.ErgebnisKonfliktChangeEvent;
import de.ivu.elect.business.ergebniskonflikt.boundary.ErgebnisKonfliktConversationStore;
import de.ivu.elect.business.ergebniskonflikt.boundary.ErgebnisKonfliktExtendedDAO;
import de.ivu.elect.business.ergebniskonflikt.boundary.ErgebnisKonfliktSearch;
import de.ivu.elect.business.ergebniskonflikt.boundary.ErgebnisKonfliktSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonflikt;
import de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonfliktMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractErgebnisKonfliktSearchView.COMPONENT_NAME)
@View(viewId = AbstractErgebnisKonfliktSearchView.VIEW_ID, useCase = UseCasePermission.ERGEBNIS_KONFLIKT_SEARCH)
public abstract class AbstractErgebnisKonfliktSearchView extends AbstractElectSearchView<ErgebnisKonflikt> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebnisKonfliktSearchView";
  
  public static final String VIEW_ID = "/ergebniskonflikt/ergebnis-konflikt-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractErgebnisKonfliktSearchView requestHandler;

  @Inject
  private transient ErgebnisKonfliktExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(ErgebnisKonfliktConversationStore.class)
  protected transient ErgebnisKonfliktConversationStore conversationStore;

  @Inject
  protected transient ErgebnisKonfliktSearch search;

  @Inject
  @ConversationGroup(AbstractErgebnisKonfliktSearchParameters.class)
  protected transient ErgebnisKonfliktSearchParameters searchParameters;

  @Inject
  protected transient ErgebnisKonfliktMeta entityMeta;

  public AbstractErgebnisKonfliktSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public ErgebnisKonflikt getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(ErgebnisKonflikt entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public ErgebnisKonfliktSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<ErgebnisKonflikt> getEagerLoadingCollector() {
    return EagerLoadingCollector.<ErgebnisKonflikt> create();
  }

  @Override
  public List<ErgebnisKonflikt> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<ErgebnisKonflikt> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onErgebnisKonfliktChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) ErgebnisKonfliktChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractErgebnisKonfliktSearchView {

    @View
    @Inject
    private transient Instance<AbstractErgebnisKonfliktSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractErgebnisKonfliktSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
